part of masamune.sns;

extension SNSBlockFilteringIDataCollectionExtension on Iterable<IDataDocument> {
  Iterable<IDataDocument> filterByBlock(
      {String key = "user", int limit = 999999, String userId = "[UID]"}) {
    return this.where((e) {
      final block = BlockCollectionModel(userId: userId, limit: limit);
      final user = e.getString(key);
      if (user == null) return false;
      if (block == null || block.length <= 0) return true;
      return block.any((element) => element.uid == user);
    });
  }
}

extension SNSBlockFilteringFutureIDataCollectionExtension
    on Future<Iterable<IDataDocument>> {
  Future<Iterable<IDataDocument>> filterByBlock(
      {String key = "user", int limit = 999999, String userId = "[UID]"}) {
    return this.then((t) {
      return t.where((e) {
        final block = BlockCollectionModel(userId: userId, limit: limit);
        final user = e.getString(key);
        if (user == null) return false;
        if (block == null || block.length <= 0) return true;
        return block.any((element) => element.uid == user);
      });
    });
  }
}
